C     This program creates a binary GIDS format file 
C     from GEISA GIDS ASCII
C             Version 1.0 for 127 bytes record length
C            22/03/2001
C
      Real*8 Position
C      Character*10 Init_Int
c      Real*8 Init_Int
      Character*1 SignE    ! sign of a transition probability power
c      Real*4 RR_I          ! Real part of intensity probability
c      Integer*2 Power_I    !  Power  of intensity 
      Real*8 Intensity      ! different for GEISA standard format !!! 
      Integer*2 RR_int
      Character*1 Ch_power_I
      Real*4 RR_P          ! Real part of transition probability
      Integer*2 Power_P    !  Power  of transition probability
      Integer*2 RR_Prob
      Character*1 Ch_power_P
      Real*4  Init_Hw
      Integer*2 Hw
      Real*8 EnergyLow
      Character*36 Ident
      Real*4 Init_TC
      Character*1 TC
      Integer*2 Isot, Init_Mol
      Character*1 Mol, Gs_ident
      Integer*2 Init_HMol
      Character*1 HIsot,HMol
      Real*4 Init_Hself
      Integer*2 HSelf
      Real*4 Hshift
      Character*9 HIndices
      Integer*4 HIRA, Nlines
C
C             GIDS related fields
      REAL*4 G1,G6,G7,G11,G12
      REAL*8 G2,G3
      CHARACTER*1 G5,G9,G10,G13,G14
      INTEGER*2 G4,G8
C             Auxilary GIDS variables:
      REAL*4 G4_R, G5_R,G8_R,G9_R,G10_R,G13_R,G14_R 
      Integer*2 Rlength
      Nlines=0
      Rlength=127 ! Atention !!!
      open(2,access='direct',form='unformatted',Recl=Rlength)
1     READ(10,1000,err=100,end=200) Position,Intensity,Init_Hw,
     *EnergyLow,Ident,Init_TC,Isot,Init_Mol,Gs_Ident,Init_Hmol,
     *HIsot,RR_P,SignE,Power_P,Init_HSelf,Hshift,HIndices,
     *G1,G2,G3,G4_R,G5_R,G6,G7,G8_R,G9_R,G10_R,G11,G12,G13_R,G14_R
c      print *, SignE  
c       print *, HIsot
C      Transformation of some fields 
c      RR_Int=Int(1000*RR_i)
c      Ch_Power_I=Char(Power_I)                 
      Hw=Int(Init_Hw*10000)
      TC=Char(Int(Init_TC*100))
      Mol=Char(Init_Mol)
      HMol=Char(Init_HMol)
      RR_Prob=Int(1000*RR_P)       
      HSelf=Int(Init_HSelf*10000)
      if (SignE.eq.'+') Power_P=Power_P+100
      Ch_Power_P=Char(Power_P)
      HIRA=I_funct(Hindices)
C        Transformations of some GIDS fields      
C
      G4=Int(G4_R*10000)
      G5=Char(Int(G5_R*100))
      G8=Int(G8_R*10000)
      G9=Char(Int(G9_R*100))
      G10=Char(Int(G10_R*100))
      G13=Char(Int(G13_R*100))
      G14=Char(Int(G14_R*100))
      
c      write(50,1000)Position,Intensity,Init_Hw,
c    *EnergyLow,Ident,Init_TC,Isot,Init_Mol,Gs_Ident,Init_Hmol,
c    *HIsot,RR_P,SignE,Power_P,Init_HSelf,Hshift,HIndices,
c    *G1,G2,G3,G4_R,G5_R,G6,G7,G8_R,G9_R,G10_R,G11,G12,G13_R,G14_R
C
            
1000  FORMAT(F12.6,D11.4,F6.4,F10.4,A36,F4.2,I3,I3,A1,I2,a1,
     *F6.3,1x,A1,I2,F5.4,F8.6,A9,F6.4,F10.6,D11.4,F6.4,F4.2,
     *F8.6,F6.4,F5.4,F4.2,F4.2,2F8.6,2F4.2)
     
      NLines=NLines+1
      Write(2,Rec=Nlines) Position,Intensity,Hw,EnergyLow,
     *Ident(1:36),
     *TC,Isot,Mol,Gs_Ident,Hmol,HIsot,RR_Prob,Ch_Power_P,HSelf,
     *HShift,HIRA,G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,G12,G13,G14  
      if ( MOD(NLines,1000).EQ.0) Print *, 'J''ai lu ',NLines,' raies'
      go to 1
 100  Print *, 'Error of reading: line number ',NLines
 200  close(2)
       go to 505
C            **** DEbuging *****
      open(2,access='direct',form='unformatted',Recl=Rlength)
      do i=1,10
      Read(2,Rec=i) Position,Intensity,Hw,EnergyLow,
     *Ident(1:36),
     *TC,Isot,Mol,Gs_Ident,Hmol,HIsot,RR_Prob,Ch_Power_P,HSelf,
     *HShift,HIRA,G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,G12,G13,G14 
      Init_Hmol=IChar(Hmol)        
      write(55,*)  Position,Intensity,Hw,EnergyLow,Ident(1:36),
     *TC,Isot,Mol,Gs_Ident,Init_Hmol,HIsot,HProbab,HSelf,HShift,HIRA,
     *G1,G2,G3,G4,IChar(G5)
      end do 
505      stop
      end
      
      Integer*4 Function I_funct(A)
      Integer*4 t
      Character*9 A
      DO I=1,9
      if (A(i:i).EQ.' ') A(i:i)='0'
      End do
      read(A,'(I9)') t
      I_funct=t
      return
      end
      
      Real*4 Function New_Int(A)
      Character*10 A, B
      Character*3 P
      integer*2 J
      Real*4 SS
      B=A
      P=A(8:10)
      read(P,'(I3)') J
      J=J+50
      write(P,'(A3)') J
      if (J.GE.0) B(8:8)='+'
      if (J.LT.0) B(8:8)='-'
      B(1:7)=A(1:7)
      B(9:10)=P(2:3)
      read(B,'(E10.3)') SS
      New_Int=SS
      Return
      End
      
      
      
      
         
      
      
      
      
      
      
