C
C           This program allows the user to pass from "Old" to "New"
C            GEISA ASCII format data file
C            Reading/Writing from/to StdInp/StdOut
C           
C            Developed at November, 2000
C
      
C         Variables for fields with the same format
      CHARACTER*10 Intens
      CHARACTER*40 C40
      Character*3 GMol
      Character*35 C35
C       Variables for fields with changes in format
      Character*10 Old_Pos
      Character*12 New_Pos
      Character*5 Old_Hw
      Character*6 New_HW
      Character*10 Old_Enl, New_Enl
      Character*4 Old_Isot
      Character*3 New_Isot
      Character*3 Old_Gident
      Character*1 New_Gident
      Character*120 Old_Line, New_Line
C
      Integer*4 Nlines
      Common /NN/NLines
      Nlines=0
1     Read(*,'(A120)', end=500) Old_Line
      Old_Pos=Old_Line(1:10)
      Intens=Old_Line(11:20)
      Old_Hw=Old_Line(21:25)
      Old_Enl=Old_Line(26:35)
      C40=Old_Line(36:75)
      Old_Isot=Old_Line(76:79)
      GMol=Old_Line(80:82)
      Old_Gident=Old_Line(83:85)
      C35=Old_Line(86:120)
      NLines=NLines+1
C      Transformation of some fields      
      Call Tr_Pos(Old_Pos,New_Pos)
      New_Hw=Old_Hw(1:5)//'0'
      Call Tr_Enl(Old_Enl,New_Enl)
      New_Isot=Old_Isot(2:4)
      Call Tr_Gident(Old_Gident,New_Gident)
      New_Line=New_Pos(1:12)//Intens(1:10)//New_Hw(1:6)//
     *New_Enl(1:10)//C40(1:40)//New_Isot(1:3)//GMol(1:3)//
     *New_GIdent(1:1)//C35(1:35)
c      if ( MOD(Nlines,2000).EQ.0) Print *, 'J''ai lu ',Nlines,' raies'
      write(*,'(A120)') New_Line(1:120)
      go to 1
C     Print *, 'Program is terminated'
500      stop
      end
C     
C     Subroutines
C
      Subroutine Tr_Pos(Pold,PNew)
      Character*10 Pold
      Character*12 PNew
      integer*2 Point
      Integer*4 NLines
      Common /NN/Nlines
      Pnew='  0000000000'
      Point=Index(Pold,'.')
      if (Point.eq.4) PNew(3:12)=Pold(1:10)
      if (Point.eq.5) PNew(2:11)=Pold(1:10)
      if (Point.eq.6) Pnew(1:10)=Pold(1:10)
      if (Point.lt.4.or.Point.gt.6) then
        Print *, 'Attention! Invalid format at line ',Nlines
        Stop
      end if
      Return
      End
      
      Subroutine Tr_Gident(Iold,Inew)
      Character*3 Iold
      Character*1 Inew
      Integer*4 Nlines
      Character*2 Year
      Common /NN/Nlines
      Inew='0'
      Year=Iold(2:3)
      if (Year.eq.'84') Inew='A'
      if (Year.eq.'92'.Or.Year.Eq.'91') Inew='B'
      if (Year.eq.'96'.Or.Year.eq.'97') Inew='C'
      if (Inew.Eq.'0') Write(17,*) Nlines,Iold
      Return
      End
      
      Subroutine Tr_Enl(EOld,ENew)
      Character*10 EOld,ENew
      ENew(10:10)='0'
      ENew(1:9)=EOld(2:10)
      Return
      End
      
      
      
      
      
      
      
      
      